config/routes.rb
Rails.application.routes.draw do
  devise_for :users

  root 'home#index'
  resources :products
  resources :likes, :only => ['create', 'destroy']
  get "/total_likes_day_wise" => "products#get_total_likes_day_wise", :as => 'total_likes_day_wise'

end

app/models/category.rb
class Category < ActiveRecord::Base
	has_many :products
end

app/models/like.rb
class Like < ActiveRecord::Base
	
	belongs_to :likeable, :polymorphic => true

	after_create :increament_likes_count
	before_destroy :decrement_likes_count

	def increament_likes_count
		self.likeable.update_column('likes_count', self.likeable.likes_count + 1)
	end

	def decrement_likes_count		
		self.likeable.update_column('likes_count', self.likeable.likes_count == 1 ? 0 : self.likeable.likes_count - 1)
	end

	def self.create_record(params)
		Like.create(:liker_id => params[:liker_id], :likeable_id => params[:likeable_id], :likeable_type => params[:likeable_type])
	end

	def self.get_record(likeable_id, likeable_type, user_id)
		Like.where(:liker_id => user_id, :likeable_id => likeable_id, :likeable_type => likeable_type).last
	end
end

app/models/product.rb
class Product < ActiveRecord::Base
	belongs_to :category
	has_many :likes, :as => :likeable, :dependent => :destroy
end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception

  def after_sign_in_path_for(resource)
  	root_path
	end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
	def index
		@categories = Category.all
	end
end

app/controllers/likes_controller.rb
class LikesController < ApplicationController
	
	before_action :authenticate_user!

	def create
		@like = Like.create_record(params)
	end


	def destroy
		like = Like.find_by_id(params[:id])
		like.destroy
		render "likes/create.js"
	end

end

app/controllers/products_controller.rb
class ProductsController < ApplicationController
	def index
		if params[:c_id].present?
			@category = Category.find_by_id(params[:c_id])
			if @category.present?
				@products = @category.products
			end
		end
	end

	def get_total_likes_day_wise
	end

	def show
		@product = Product.find(params[:id])
	end
end

app/helpers/application_helper.rb
module ApplicationHelper
	def check_if_already_liked(likeable_id, likeable_type, user_id)
		like = Like.get_record(likeable_id, likeable_type, user_id)
	end
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/likes_helper.rb
module LikesHelper
end

app/helpers/products_helper.rb
module ProductsHelper
end

app/views/home/index.html.haml
- if @categories.present?
	.panel.panel-default
		.panel-heading Click on any category to get all products belonging to that category
	%table.table
		%th Category 
		
		- @categories.each do |category|
			%tr
				%td
					=link_to category.name.capitalize, products_path(:c_id => category.id)
				
- else
	.panel.panel-default
		.panel-heading Seems you have not added any category or products yet!			

app/views/layouts/_header.html.haml
%nav.navbar.navbar-default{:role => "navigation"}
  .container
    .navbar-header
      %button.navbar-toggle.collapsed{"data-target" => "#bs-example-navbar-collapse-1", "data-toggle" => "collapse", :type => "button"}
        %span.sr-only Toggle navigation
        %span.icon-bar
        %span.icon-bar
        %span.icon-bar
      = link_to "Flipkkart", root_path, class: "navbar-brand"
    / Collect the nav links, forms, and other content for toggling
    #bs-example-navbar-collapse-1.collapse.navbar-collapse
      %ul.nav.navbar-nav
        - if user_signed_in?
          %li= link_to "Sign Out", destroy_user_session_path, :method => 'delete', class: "active"
          %li= link_to "Total likes day wise", total_likes_day_wise_path, class: "active"
        - else
          %li= link_to "Sign Up", new_user_registration_path, class: "active"
          %li= link_to "Sign In", new_user_session_path, class: "active"
     

app/views/layouts/application.html.haml
!!!
%html
	%head
		%meta{:content => "text/html; charset=UTF-8", "http-equiv" => "Content-Type"}/
		%title IntelliswiftTask
		= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true
		= javascript_include_tag 'application', 'data-turbolinks-track' => true
		= javascript_include_tag "https://www.gstatic.com/charts/loader.js"
		= csrf_meta_tags
	%body
		= render 'layouts/header'
		.container
			= yield

app/views/likes/_like_dislike.html.haml
- already_liked = check_if_already_liked(likeable_id, "Product", current_user.id)
- if already_liked.present?
	= link_to "Unlike", like_path(:id => already_liked.id, :likeable_id => likeable_id) , :remote => true, :method => 'delete', :class => 'btn btn-default'
- else
	= link_to 'Like', likes_path(:likeable_id => likeable_id, :likeable_type=> "Product", :liker_id => current_user.id), :method => 'post', :remote => true, :class => 'btn btn-primary'

app/views/likes/create.js.erb
$(".<%= params[:likeable_id]%>").html('<%= escape_javascript(render :partial => "likes/like_dislike", :locals => { :likeable_id => params[:likeable_id]}) %>');

app/views/products/get_total_likes_day_wise.html.haml
%h3 Total likes day wise : 
%br
= line_chart Like.group_by_day(:created_at).count
%h6 note* : value in the chart indicates total count

app/views/products/index.html.haml
- if @products.present?
	.panel.panel-default
		.panel-heading 
			= @category.name.capitalize if @category.present?
	%table.table
		%th Product
		%th Description
		%th Action
		
		- @products.each do |product|
			%tr
				%td
					= link_to product.title, product_path(product)
				%td
					= product.description
				%td
					- if user_signed_in? 
						#like_dislike{:class => product.id}
							= render :partial => "likes/like_dislike", :locals => {:likeable_id => product.id}
					- else
						= link_to 'Like', new_user_session_path, :class => 'btn btn-primary'
											
				
- else
	.panel.panel-default
		.panel-heading Seems there are no products available for this category :(

app/views/products/show.html.haml
%h3 Likes on product day wise : 
%br
= line_chart @product.likes.group_by_day(:created_at).count
%br
%h6 note* : value in the chart indicates total count